import appia.*;

import appia.protocols.udpsimple.*;
import appia.protocols.fifo.*;
import appia.protocols.prdAppl.*;
import appia.protocols.group.*;

/* Alterar o nome do package aqui */
import appia.protocols.totalTemplate.*;
/* Fim alteracao */

public class prd {
    
    public static void main(String args[]) {

	int port=-1;
	int rank=-1;
	String vista=null;

	/* Argument parsing */

	if(args.length<6) {
	    System.err.println("Numero de argumentos invalidos.");
	    argsInvalidos();
	}

	if(args[0].equals("-porto")) {
	    try {
		port=Integer.parseInt(args[1]);
	    }
	    catch(NumberFormatException ex) {
		System.err.println("Porto Invalido: "+args[1]);
		return;
	    }
	}
	else argsInvalidos();
	if(args[2].equals("-rank")) {
	    try {
		rank=Integer.parseInt(args[3]);
	    }
	    catch(NumberFormatException ex) {
		System.err.println("Rank Invalido: "+args[3]);
		return;
	    }
	}
	else argsInvalidos();
	if(!args[4].equals("-vista"))
	    argsInvalidos();

	/* Create layers and put them on a array*/

	Layer[] qos=new Layer[9];
	qos[0]=new UdpSimpleLayer();
	qos[1]=new FifoLayer();
	qos[2]=new GroupBottomLayer();
        qos[3]=new SuspectLayer();
        qos[4]=new StableLayer();
        qos[5]=new SyncLayer();
        qos[6]=new IntraLayer();
	qos[8]=new PrdApplLayer();

	/* Alterar o nome aqui */
	qos[7]=new TotalTemplLayer();
	/* Fim de alteracao */


	/* Create a QoS */
	QoS myQoS=null;
	try {
	    myQoS=new QoS("PRDQOS",qos);
	}
	catch(AppiaInvalidQoSException ex) {
	    System.err.println("Invalid QoS");
	    System.err.println(ex.getMessage());
	    return;
	}

	/* Create a channel. Uses default event scheduler. */
	Channel c=myQoS.createUnboundChannel("canalPRD");
	
	/* Application Session requires special arguments: qos and port.
	   A session is created and binded to the stack. Remaining ones
	   are created by default 
	*/

	PrdApplSession as=(PrdApplSession)qos[8].createSession();

	try {
	    as.init(port,rank,args,5);
	}
	catch(java.net.UnknownHostException ex) {
	    System.err.println("Pelo menos um dos nomes de maquinas "+
			       "passados como argumento do grupo "+
			       "nao e' valido");
	    return;
	}
	catch(appia.protocols.group.AppiaGroupException ex) {
	    System.err.println("Excepcao na criacao do grupo");
	}

	ChannelCursor cc=c.getCursor();

	/* Application is the last session of the array. Positioning
	   in it is simple */
       
	try {
	    cc.top();
	    cc.setSession(as);
	}
	catch(AppiaCursorException ex) {
	    System.err.println("Unexpected exception in main. Type code:"+
			       ex.type); 
	    return;
	}

	/* Remaining ones are created by default. Just tell the channel
	   to start */
	try {
	    c.start();
	}
	catch(AppiaDuplicatedSessionsException ex) {
	    System.err.println("Sessions binding strangely resulted in "+
			       "one single sessions occurring more than "+
			       "once in a channel");
	    return;
	}

	/* All set. Appia main class will handle the rest */

	Appia.run();
    }

    private static void argsInvalidos() {
	System.err.println("Parametros insuficientes.");
	System.err.println("Utilizacao: java prd " +
			   "-porto <porto UDP> -rank <posicao na vista> "+
			   "-vista IP:Porto IP:Porto ...");
	System.exit(1);
    }
}